-- /run for i=1,40 do local name, _, icon, count, type, duration, exp, unitCaster, isStealable, _, spellId=UnitBuff("player",i); if name then type=debuffType or "other"; print(type.." "..count.." "..name.."("..exp..")".." = "..spellId) end end
-- /run for i=1,40 do local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId=UnitDebuff("target",i); if name then print(name.."="..spellId) end end
-- /run for i=1,40 do local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId=UnitBuff("pet",i); if name then print(count.." "..name.."("..expirationTime..")".." = "..spellId) end end
-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.AddDOT = function(guid)
	cfg.TargetsDOT[guid]=cfg.now
	cfg.UpdateDOT=true
end

lib.DelDOT = function(guid)
	cfg.TargetsDOT[guid]=nil
	cfg.UpdateDOT=true
end

lib.NumDOT = function()
	cfg.TotalTargets=0
	for guid,value in pairs(cfg.TargetsDOT) do
		if cfg.now>(cfg.TargetsDOT[guid]+cfg.maxDOTtime) then
			cfg.TargetsDOT[guid]=nil
		else
			cfg.TotalTargets=cfg.TotalTargets+1
		end
	end
	return cfg.TotalTargets
end

lib.UpdateDOT = function()
	if cfg.TotalTargets>0 then 
		Heddframe.DOT.text:SetText(cfg.TotalTargets)
	else
		Heddframe.DOT.text:SetText(" ")
	end
end

local lastUpdateDOT = 0
local ptargets
lib.OnUpdateDOT = function (self, elapsed)
	elapsed = elapsed or 0
	lastUpdateDOT = lastUpdateDOT + elapsed
	if cfg.UpdateDOT or lastUpdateDOT > cfg.freq then
		ptargets=cfg.TotalTargets
		if ptargets~=lib.NumDOT() then
			lib.UpdateDOT()
			cfg.Update=true
		end
		lastUpdateDOT = 0
		cfg.UpdateDOT=nil
	end	
end

lib.SetBUFF=function(guid,num)
	num = num or 0
	tmp = nil
	if cfg.TargetsBUFF[guid] then 
		tmp=cfg.TargetsBUFF[guid]
	--	print(cfg.now.." "..guid.." BUFF applied "..num)
	end
	
	if num>0 then
		cfg.TargetsBUFF[guid]=num
	else
		cfg.TargetsBUFF[guid]=nil
	end
	if tmp~=cfg.TargetsBUFF[guid] then
		cfg.Update=true
	end
	
end

lib.GetBUFF=function(guid)
	if guid then
		if cfg.TargetsBUFF[guid] and lib.GetAura({cfg.TrackBUFF})>0 then
			return cfg.TargetsBUFF[guid]
		end	
	end
	return 0
end

lib.UpdateBUFF=function()
	tmp=lib.GetBUFF(cfg.targetGUID)
	if tmp>0 then
		Heddframe.BUFF.text:SetText(tmp) 
	else
		Heddframe.BUFF.text:SetText(" ")
	end
end

lib.AddAura = function(spell,id,atype,unit,caster,onchange)
	if not lib.Hedd_GSI(id) then return end
	if atype=="buff" then
		unit=unit or "player"
	else
		atype="debuff"
		unit=unit or "target"
	end
	
	cfg.watchunits[unit]=true
	cfg.auras[spell] ={}
	cfg.auras[spell].id=id
	cfg.auras[spell].name = lib.Hedd_GSI(id)
	cfg.id2aura[cfg.auras[spell].id]=spell
	cfg.auras[spell].duration=0
	--cfg.auras[spell].pduration=0
	cfg.auras[spell].expire=0
	--cfg.auras[spell].pexpire=0
	cfg.auras[spell].stacks=0
	cfg.auras[spell].type=atype
	cfg.auras[spell].unit=unit
	cfg.auras[spell].caster=caster or "player"
	cfg.auras[spell].present=0
	cfg.auras[spell].lasttime=0
	cfg.auras[spell].pstacks=0
	--print("Adding "..cfg.auras[spell].name)
	lib.UpdateAura(spell)
end

lib.SetAuraFunction = function(spell,event,func)
	if cfg.auras[spell] then
		if event=="OnApply" then
			cfg.auras[spell].OnApply=func
			cfg.auras[spell].OnReApply=func
		end
		if event=="OnReApply" then
			cfg.auras[spell].OnReApply=func
		end
		if event=="OnFade" then
			cfg.auras[spell].OnFade=func
		end
	end
end

lib.AddAuras = function(spell,ids,atype,unit)
	if atype=="buff" then
		unit=unit or "player"
	else
		atype="debuff"
		unit=unit or "target"
	end

	for index,id in ipairs(ids) do
		--print(spell..index.." "..id)
		lib.AddAura(spell..index,id,atype,unit,"any")
	end
end

lib.UpdateAuraAll = function(unit)
	for spell,name in pairs(cfg.auras) do
		if cfg.auras[spell].unit==unit then lib.UpdateAura(spell) end
	end
end

lib.PrintBuff = function(unit, bufftype)
	bufftype=bufftype or "Magic"
	for i=1,40 do
		local name, _, icon, count, b_type, duration, b_exp, caster, stealable, _, spellId=UnitBuff(unit,i)
		if name then
			if count==0 then count=1 end
			b_type=b_type or "Other"
			if hedlib.enrage[spellId] then b_type="Enrage" end
			if b_type==bufftype or bufftype=="all" then
				print(b_type.." "..count.." "..name.."("..b_exp..")".." = "..spellId)
			end
		end
	end
end

lib.CheckBuff = function(unit, bufftype)
	bufftype=bufftype or {"Magic"}
	local buffs={}
	for _,id in ipairs(bufftype) do
		buffs[id]=true
	end
	for i=1,40 do
		local name, _, _, _, b_type, _, _, _, _, _, spellId=UnitBuff(unit,i)
		if name then
			b_type=b_type or "Other"
			if hedlib.enrage[spellId] then b_type="Enrage" end
			if buffs[b_type] then
				return true
			end
		end
	end
	return nil
end

lib.UpdateAura = function(spell)
	if cfg.auras[spell] then
		oldtable=hedlib.shallowCopy(cfg.auras[spell])
		if cfg.auras[spell].type=="debuff" then
			atype="HARMFUL"
		else
			atype="HELPFUL"
		end
		if cfg.auras[spell].caster=="player" then
			atype=atype.." PLAYER"
		end
		found=nil
		--local i=1
		for i=1,40 do
			aname, _, _, acount, _, aduration, aexpirationTime, aunitCaster, _, _, aid = UnitAura(cfg.auras[spell].unit,i,atype)
			if cfg.auras[spell].id==aid then
				cfg.auras[spell].duration=aduration
				cfg.auras[spell].expire=aexpirationTime
				cfg.auras[spell].stacks=acount or 1
				cfg.auras[spell].present=1
				if cfg.auras[spell].stacks==0 then cfg.auras[spell].stacks=1 end
				found=true
				break
			end
		end
		if not found then
			cfg.auras[spell].duration=0
			cfg.auras[spell].expire=0
			cfg.auras[spell].stacks=0
			cfg.auras[spell].present=0
		end

		if oldtable.duration>0 and cfg.auras[spell].duration==0 then
			cfg.auras[spell].pstacks=oldtable.stacks
			cfg.auras[spell].lasttime=cfg.now
			if cfg.auras[spell].OnFade then cfg.auras[spell].OnFade() end
		end

		if oldtable.duration==0 and cfg.auras[spell].duration>0 then
			if cfg.auras[spell].OnApply then cfg.auras[spell].OnApply() end
		end
		if oldtable.expire<cfg.auras[spell].expire then
			if cfg.auras[spell].OnReApply then cfg.auras[spell].OnReApply() end
		end

		if hedlib.shallowCompare(cfg.auras[spell],oldtable) then
			cfg.Update=true
			return true
		end
	end
	return nil
end

lib.AuraId2Aura = function(id)
	return cfg.id2aura[id] or nil
end

lib.AuraInTime = function (spell , mint, maxt)
	if not cfg.auras[spell] then return nil end
	if cfg.auras[spell].lasttime >= mint and cfg.auras[spell].lasttime <=maxt then
		return true
	else
		return nil
	end
end

lib.GetAuraLastTime = function (spell)
	if cfg.auras[spell] then
		return cfg.auras[spell].lasttime
	end
	return 0
end

lib.GetAuraLastTimeStacks = function (spell)
	if cfg.auras[spell] then
		return cfg.auras[spell].pstacks
	end
	return 0
end

lib.GetAuraId = function (spell)
	if cfg.auras[spell] then
		return cfg.auras[spell].id
	end
	return "noaura"
end

lib.GetAura = function(auras)
	tl_aura = 0
	for _,n_aura in ipairs(auras) do
		if cfg.auras[n_aura] then
			tl_aura=cfg.auras[n_aura].expire-cfg.now
			tl_aura = (tl_aura>=0) and tl_aura or 0
			if cfg.auras[n_aura].present==1 and tl_aura==0 then tl_aura=99999 end
			if tl_aura>0 then 
				return tl_aura
			end
		end
	end
	return 0
end

lib.GetAuras = function(aura)
	tl_aura = 0
	i_aura=1
	notfound_aura=true
	while notfound_aura do
		n_aura=aura..i_aura
		if cfg.auras[n_aura] then
			tl_aura = cfg.auras[n_aura].expire-cfg.now
			tl_aura = (tl_aura>=0) and tl_aura or 0
			if cfg.auras[n_aura].present==1 and tl_aura==0 then tl_aura=99999 end
			if tl_aura>0 then 
				notfound_aura=nil
				return tl_aura
			end
			i_aura=i_aura+1
		else
			notfound_aura=nil
		end
	end
	return 0
end

lib.HasAuras = function(aura)
	i_aura=1
	notfound_aura=true
	while notfound_aura do
		n_aura=aura..i_aura
		if cfg.auras[n_aura] then
			if cfg.auras[n_aura].present==1 then 
				return true
			end
			i_aura=i_aura+1
		else
			notfound_aura=nil
		end
	end
	return nil
end

lib.IsAura = function(auras)
	if lib.GetAura(auras)>0 then
		return 1
	else
		return 0
	end
end

lib.GetShortestAura = function(auras)
	tl_aura=99999
	for _,n_aura in ipairs(auras) do
		if cfg.auras[n_aura] then
			tl_caura=cfg.auras[n_aura].expire-cfg.now
			tl_caura = (tl_caura>=0) and tl_caura or 0
			if tl_caura<tl_aura then tl_aura=tl_caura end
		end
	end
	if tl_aura==99999 then return 0 end
	return tl_aura
end

lib.GetLargestAura = function(auras)
	tl_aura=0
	for _,n_aura in ipairs(auras) do
		if cfg.auras[n_aura] then
			tl_caura=cfg.auras[n_aura].expire-cfg.now
			tl_caura = (tl_caura>=0) and tl_caura or 0
			if tl_caura>tl_aura then tl_aura=tl_caura end
		end
	end
	return tl_aura
end

lib.GetLargestNumber = function(numbers)
	bignumber=0
	for _,n_num in ipairs(numbers) do
		if n_num>bignumber then bignumber=n_num end
	end
	return bignumber
end

lib.GetAuraNum = function(aura)
	tl_aura=0
	if cfg.auras[aura] then
		tl_aura=cfg.auras[aura].expire-cfg.now
		tl_aura = (tl_aura>=0) and tl_aura or 0
		if cfg.auras[aura].present==1 and tl_aura==0 then tl_aura=99999 end
		if tl_aura>0 then return (cfg.auras[aura].stacks) end
	end
	return 0
end

lib.UpdateWeaponBuffs = function()
	pMain, pOff = cfg.Weapons.Main, cfg.Weapons.Off
	cfg.Weapons.Main, _, _, cfg.Weapons.Off = GetWeaponEnchantInfo()
	if pMain~=cfg.Weapons.Main or pOff~=cfg.Weapons.Off then return true end
	return false
end